/*
 * system.h - header file for misc system specific stuff
 *
 * author: hackbard@hackdaworld.org
 *
 */

#ifndef SYSTEM_H
#define SYSTEM_H

#include "lpc2xxx.h"
#include "types.h"

/* defines */

#define MEMTYPE_BOOT		0x00
#define MEMTYPE_RESERVED	0x01
#define MEMTYPE_RAM		0x02
#define MEMTYPE_EXT		0x03

/* function prototypes */
void pll_init(void);
void ext_mem_init(void);
void pin_init(void);
void mmap_init(u8 memtype);
void pause(u32 cnt);

#endif
